/**************************************************************/
//   Universidad Nacional Autnoma de Mxico
//          Facultad de Ingeniera
//
//         Ingeniera Mecatrnica
//           Amaury Prez Tirado
//
//  Sistema Ldico para ejercicios de terapia      
//      de la zona carpiana y falanges
//
//    Mexico                         2014
//
/**************************************************************/


#include<18f4550.h>
#device adc=10
#fuses HS,NOWDT,NOPROTECT,NOLVP,NODEBUG,USBDIV,PLL5,CPUDIV1,VREGEN
#use delay(clock=48MHz)
#use i2c(master,fast,sda=PIN_d1,scl=PIN_d0)
#use timer(TIMER=1,TICK=1us,BITS=16,NOISR)
//   #USE RS232(BAUD=9600, XMIT=PIN_c6, RCV=PIN_c7)
#include <usb_cdc.h>
#include <usb_desc_cdc.h>
#include <math.h>


char dato;

////////////////////////////////////////////////////////////////// ACELEROMETRO //////////////////////////////////////////////////////////

#define adxl345 0xA6

#define accel_power_ctl 0x2D
#define accel_bw_rate 0x2C
#define accel_data_format 0x31

#define accel_reg_x0 0x32
#define accel_reg_x1 0x33
#define accel_reg_y0 0x34
#define accel_reg_y1 0x35
#define accel_reg_z0 0x36
#define accel_reg_z1 0x37


signed int16 accX,accY,accZ;
signed int16 acc_X,acc_Y,acc_Z;

int8 accel_data[6];
float accfX,accfY,accfZ;

float acc_roll=0;
float acc_pitch=0;
float acc_yaw=0;
#define ACC_ALPHA  0.5 


float acc_teta;
float acc_gama;
float acc_fi;
/////////////////

float acc_pitch1=0;
float acc_roll1=0;
float acc_yaw1=0;

////////////////////////////////////////////////////////////////// ACELEROMETRO //////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////// GIROSCOPIO //////////////////////////////////////////////////////////
#define l3g4200d 0xD2
#define who_am_i 0x0F

#define ctrl_reg1 0x20
#define ctrl_reg2 0x21
#define ctrl_reg3 0x22
#define ctrl_reg4 0x23
#define ctrl_reg5 0x24
#define reference 0x25

#define out_x_l 0x28
#define out_x_h 0x29
#define out_y_l 0x2A
#define out_y_h 0x2B
#define out_z_l 0x2C
#define out_z_h 0x2D

#define GRY_SAMPLE_TIME 10 
#define GRY_SAMPLE_NUM  500 

// Actual angles
float angX = 0;
float angY = 0;
float angZ = 0;

signed int16 gyroHighX=0;
signed int16 gyroHighY=0;
signed int16 gyroHighZ=0;
signed int16 gyroLowX=500;
signed int16 gyroLowY=500;
signed int16 gyroLowZ=500;

signed int16 gyr_rate_x=0; 
signed int16 gyr_rate_y=0; 
signed int16 gyr_rate_z=0; 

signed int16 gyr_prev_rate_x=0; 
signed int16 gyr_prev_rate_y=0; 
signed int16 gyr_prev_rate_z=0; 
signed int16 gyr_dc_offset_x=0; 
signed int16 gyr_dc_offset_y=0; 
signed int16 gyr_dc_offset_z=0;

signed int16 gyrX=0;
signed int16 gyrY=0;
signed int16 gyrZ=0;
int8 gyro_data[6];
//float gyrofX,gyrofY,gyrofZ;


signed int16 p_gyrX=0;
signed int16 P_gyrY=0;
signed int16 P_gyrZ=0;

signed int16 p_gyrX2=0;
signed int16 P_gyrY2=0;
signed int16 P_gyrZ2=0;

float angGX;
float angGY;
float angGZ;

int16 n;

float time;

////////////////////////////////////////////////////////////////// GIROSCOPIO //////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////// FILTRO //////////////////////////////////////////////////////////
int1 pitchRoll_flag=0;

float valPitch=0;
float valRoll=0;

float valPitch2=0;
float valRoll2=0;

////////////////////////////////////////////////////////////////// FILTRO //////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////// FLEXOMETRO //////////////////////////////////////////////////////////

int8 behavior=0;

int1 agitado=0;

long int pot=0;
long int pot22=0;
long int pot2=0;
long int pot12=0;
long int flex=0;

long int potaux=0;
long int potant=0;
long int potaux22=0;
long int potant22=0;

signed long int error=0;
signed long int errorA=0;
signed long int errorD=0;
signed long int errorI=0;

signed long int salida=0;
signed long int salidaS=0;


signed long int error2=0;
signed long int errorA2=0;
signed long int errorD2=0;
signed long int errorI2=0;

signed long int salida2=0;
signed long int salidaS2=0;

float Kp=2;
float Kp2=2;
float Kd=3;
float Kd2=2;
float Ki=0.3;


float refInf=900;
float refSup=970;
float refInf2=230;
float refSup2=300;
float paso1=7;
float paso2=7;

////////////////////////////////////////////////////////////////// FLEXOMETRO //////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////// I2C //////////////////////////////////////////////////////////

void escribeRegistro(int8 deviceAddress,int8 address,int8 config) 
 { 
    i2c_start(); 
    i2c_write(deviceAddress);      
    i2c_write(address);        
    i2c_write(config);            
    i2c_stop();
 }

int8 leeRegistro(int8 deviceAddress,int8 address)
{
   int v;
    i2c_start(); 
    i2c_write(deviceAddress);      
    i2c_write(address);        
     i2c_start(); 
    i2c_write(deviceAddress+1);
   v=i2c_read(0);     
    i2c_stop();

   return v;
}

////////////////////////////////////////////////////////////////// I2C //////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////// ACELEROMETRO //////////////////////////////////////////////////////////
void iniciarADXL345()
{
   escribeRegistro(adxl345,accel_data_format,0x01);
   escribeRegistro(adxl345,accel_power_ctl,0x08); //Messure Mode ON
}

void leeAcelerometro()
{
accel_data[0]=leeRegistro(adxl345,accel_reg_x0);
accel_data[1]=leeRegistro(adxl345,accel_reg_x1);
accel_data[2]=leeRegistro(adxl345,accel_reg_y0);
accel_data[3]=leeRegistro(adxl345,accel_reg_y1);
accel_data[4]=leeRegistro(adxl345,accel_reg_z0);
accel_data[5]=leeRegistro(adxl345,accel_reg_z1);

accX=make16(accel_data[1],accel_data[0]);
accY=make16(accel_data[3],accel_data[2]);
accZ=make16(accel_data[5],accel_data[4]);

//Low Pass Filter 
acc_x=accX*ACC_ALPHA+(acc_x*(1.0-ACC_ALPHA)); 
acc_y=accY*ACC_ALPHA+(acc_y*(1.0-ACC_ALPHA)); 
acc_z=accZ*ACC_ALPHA+(acc_z*(1.0-ACC_ALPHA)); 
}

void mathAcelerometro()
{
float accR=sqrt((float)acc_X*(float)acc_X+(float)acc_Y*(float)acc_Y+(float)acc_Z*(float)acc_Z);
accfX=(float)acc_X/accR; 
accfY=(float)acc_Y/accR; 
accfZ=(float)acc_Z/accR;
}

void acc_sphera()
{ //angles of rotation beetwen the vector gravity and each sensor's axis (orthogonal coordinates system). 
acc_teta=acos(accfx)*180/PI; 
acc_gama=acos(accfy)*180/PI; 
acc_fi=acos(accfz)*180/PI; 
} 

void acc_angulos()
{
acc_pitch=(atan2(accfX,sqrt((float)accfY*(float)accfY+(float)accfZ*(float)accfZ))*180.0)/PI+180;
acc_roll=(atan2(accfY,sqrt((float)accfX*(float)accfX+(float)accfZ*(float)accfZ))*180.0)/PI+180;
acc_yaw=(atan2(sqrt((float)accfX*(float)accfX+(float)accfY*(float)accfY),accfZ)*180.0)/PI+180;

acc_pitch=acc_pitch-180;
acc_roll=acc_roll-180;
acc_yaw=acc_yaw-180;
}

void CalibrateAccel()
{
      leeAcelerometro();
      mathAcelerometro();
   //   acc_sphera();
      acc_angulos();

acc_pitch1=acc_pitch;
acc_roll1=acc_roll;
acc_yaw1=acc_yaw;

}

////////////////////////////////////////////////////////////////// ACELEROMETRO //////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////// GIROSCOPIO //////////////////////////////////////////////////////////

void inciarL3G4200D()
{
   //escribeRegistro(l3g4200d,ctrl_reg1,0x1f);
   escribeRegistro(l3g4200d,ctrl_reg1,0x0f);
   escribeRegistro(l3g4200d,ctrl_reg2,0x00);
   escribeRegistro(l3g4200d,ctrl_reg3,0x00);
   escribeRegistro(l3g4200d,ctrl_reg4,0x80);
   escribeRegistro(l3g4200d,ctrl_reg5,0x00);
   delay_us(1000);
}

void leerGiroscopo()
{
gyro_data[0]=leeRegistro(l3g4200d,out_x_l);
gyro_data[1]=leeRegistro(l3g4200d,out_x_h);
gyro_data[2]=leeRegistro(l3g4200d,out_y_l);
gyro_data[3]=leeRegistro(l3g4200d,out_y_h);
gyro_data[4]=leeRegistro(l3g4200d,out_z_l);
gyro_data[5]=leeRegistro(l3g4200d,out_z_h);

gyrX=make16(gyro_data[1],gyro_data[0]);
gyrY=make16(gyro_data[3],gyro_data[2]);
gyrZ=make16(gyro_data[5],gyro_data[4]);

gyrX=(gyrX*0.5+P_gyrX*0.5);
gyrY=(gyrY*0.5+P_gyrY*0.5);
gyrZ=(gyrZ*0.5+P_gyrZ*0.5);

gyrX=(gyrX*0.33+P_gyrX*0.33+P_gyrX2*0.33);
gyrY=(gyrY*0.33+P_gyrY*0.33+P_gyrY2*0.33);
gyrZ=(gyrZ*0.33+P_gyrZ*0.33+P_gyrZ2*0.33);


p_gyrX2=P_gyrX;
P_gyrY2=P_gyrY;
P_gyrZ2=P_gyrZ;

p_gyrX=gyrX;
P_gyrY=gyrY;
P_gyrZ=gyrZ;

}

void calibrateGyro()
{
 printf(usb_cdc_putc,"Calibrating gyro, don't move!");
  for(n = 0; n <= 500; n++) {
    leerGiroscopo();
 // printf(usb_cdc_putc,"%u ",i);
//       printf(usb_cdc_putc,"%Ld,%Ld,%Ld\n\r",gyrX,gyroHighX,gyroLowX);
    if(gyrx > gyroHighX)
      gyroHighX = gyrx-10;
    else if(gyrx < gyroLowX)
      gyroLowX = gyrx+10;
 
    if(gyry > gyroHighY)
      gyroHighY = gyry-10;
    else if(gyry < gyroLowY)
      gyroLowY = gyry+10;
 
    if(gyrz > gyroHighZ)
      gyroHighZ = gyrz-10;
    else if(gyrZ < gyroLowZ)
      gyroLowZ = gyrz+10;
    
    delay_us(10);
  }
 //printf(usb_cdc_putc,"Calibration complete.");
}

void calibrateGyro2()
{
// printf(usb_cdc_putc,"Calibrating gyro, don't move!");
  for(n = 0; n <= 500; n++) {
    leerGiroscopo();
 // printf(usb_cdc_putc,"%u ",i);

     gyr_dc_offset_x+=gyrx; 
     gyr_dc_offset_y+=gyry; 
     gyr_dc_offset_z+=gyrz; 
   } 

   gyr_dc_offset_x=gyr_dc_offset_x/GRY_SAMPLE_NUM; 
   gyr_dc_offset_y=gyr_dc_offset_y/GRY_SAMPLE_NUM; 
   gyr_dc_offset_z=gyr_dc_offset_z/GRY_SAMPLE_NUM;

 printf(usb_cdc_putc,"Calibration complete.");
}


void mathGyro()
{
    gyr_rate_x=(gyrx-gyr_dc_offset_x)*0.065; 
      gyr_rate_y=(gyry-gyr_dc_offset_y)*0.065; 
      gyr_rate_z=(gyrz-gyr_dc_offset_z)*0.065; 
 
  // Calculate angles
  if(gyrx >= gyroHighX || gyrx <= gyroLowX) {
angGX= ((float)(gyr_prev_rate_x + gyr_rate_x) *5.5)/ 2000;
angX=angX+angGX;
  }
else
{
angGX=0;
}
 
  if(gyry >= gyroHighY || gyry <= gyroLowY) {
angGY = ((float)(gyr_prev_rate_y + gyr_rate_y) * 5.5) / 2000; 
angY=angY-angGY;
}
else
{
angGY=0;
}
 
  if(gyrz >= gyroHighZ || gyrz <= gyroLowZ) {
angGZ = ((float)(gyr_prev_rate_z + gyr_rate_z) * 5.5) / 2000;
angZ=angZ+angGZ;
  }
else
{
angGZ=0;
}

      gyr_prev_rate_x = gyr_rate_x; 
      gyr_prev_rate_y = gyr_rate_y; 
      gyr_prev_rate_z = gyr_rate_z; 

   // Keep our angle between 0-359 degrees

      if (angX < -180) angX += 360; 
      else if (angX >= 180) angX -= 360; 

      if (angY < -180) angY += 360; 
      else if (angY >= 180) angY -= 360; 

      if (angZ < -180) angZ += 360; 
      else if (angZ >= 180) angZ -= 360;

}

////////////////////////////////////////////////////////////////// GIROSCOPIO //////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////// FILTRO //////////////////////////////////////////////////////////
void Filtro()
{
valPitch-=angGY;
valRoll+=angGX;
valPitch=0.96*valPitch+0.04*acc_pitch;
valRoll=0.96*valRoll+0.04*acc_roll;

//valPitch=0.5*valPitch+0.5*valPitch2;
//valRoll=0.5*valRoll+0.5*valRoll2;

valPitch2=valPitch;
valRoll2=valRoll;

      if (valPitch < -180) valPitch += 360; 
      else if (valPitch >= 180) valPitch -= 360; 

      if (valRoll < -180) valRoll += 360; 
      else if (valRoll >= 180) valRoll -= 360; 
}
////////////////////////////////////////////////////////////////// FILTRO //////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////// METODOS IMU//////////////////////////////////////////////////////////

   void imu()
   {
      leeAcelerometro();
      mathAcelerometro();
      acc_sphera();
      acc_angulos();
      time=get_ticks();

      if(time>10000)
      {
         leerGiroscopo();
         mathGyro();
         Filtro();
         set_ticks(0);
      }

      if(pitchRoll_flag)
      printf(usb_cdc_putc,"%f,%f\n\r",valPitch,valRoll);
   }

////////////////////////////////////////////////////////////////// METODOS IMU//////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////// MOTORES //////////////////////////////////////////////////////////
long int clamp(long int valor,long int max,long int min)
{
if(valor>max)
return max;
else if(valor<min)
return min;
else
return valor;
}


void direccion(int1 giro)
{
   if(giro)
   {
    OUTPUT_low(pin_C6);
   OUTPUT_HIGH(pin_C7);
   }
   else
   {
   output_low(pin_C7);
   OUTPUT_HIGH(pin_C6);
   }
}

void direccion2(int1 giro2)
{
   if(giro2)
   {
    OUTPUT_low(pin_b4);
   OUTPUT_HIGH(pin_b3);
   }
   else
   {
   output_low(pin_b3);
   OUTPUT_HIGH(pin_b4);
   }
}


long int flexA=0;
long int flexAA=0;
//long int flexAAA;


void flexometro()
{
      delay_us(100);
      set_adc_channel(2);
      flex=read_ADC();
      while(!adc_done()){}
      delay_us(100);
      flex=(flex+flexA)/2;
      flex=(flex+flexA+flexAA)/3;
   //   flex=(flex+flexA+flexAA+flexAAA)/4;
   //   flexAAA=flexAA;
      flexAA=flexA;
      flexA=flex;
}


void control1()
{
      errorD=error-errorA;
      errorI=errorI+error;
      salida=Kp*error+Kd*errorD+Ki*errorI;

      if(salida>920)
      salida=920;
      else if (salida<-920)
      salida=-920;

      //salida=Kp*error;
   //   salidaS=abs(salida);
      delay_us(100);
      salidaS=250+clamp(abs(salida),620,0);


      delay_us(100);
      set_pwm2_duty(salidaS);
      delay_us(100);

      if(error<6&&error>-6)
      {
      output_low(pin_b3);
      output_low(pin_b4);
      errorI=0;
      }      
      else
      {
      direccion(error>0);
            delay_us(100);
      }
      errorA=error;
}

void control2()
{
      errorD2=error2-errorA2;
      errorI2=errorI2+error2;
      salida2=Kp2*error2+Kd2*errorD2+Ki*errorI2;

      if(salida2>920)
      salida2=920;
      else if (salida2<-920)
      salida2=-920;

      //salida=Kp*error;
   //   salidaS=abs(salida);
      delay_us(100);
      salidaS2=100+clamp(abs(salida2),770,0);


      delay_us(100);
      set_pwm1_duty(salidaS2);
      delay_us(100);

      if(error2<6&&error2>-6)
      {
      output_low(pin_C6);
      output_low(pin_C7);
      errorI2=0;
      }      
      else
      {
      direccion2(error2>0);
            delay_us(100);
      }

      errorA2=error2;
}


void vel2()
{

      salidaS2=900;
      delay_us(100);
      set_pwm1_duty(salidaS2);
      delay_us(100);

   output_low(pin_b3);
   OUTPUT_HIGH(pin_b4);
}

void vel1()
{
      salidaS=900;
      delay_us(100);
      set_pwm2_duty(salidaS);
      delay_us(100);

    OUTPUT_low(pin_C6);
   OUTPUT_HIGH(pin_C7);
}


void error_1()
{
      delay_us(200);         
      set_adc_channel(0);
      potaux=read_ADC();
      while(!adc_done()){}
      pot=(potaux+potant)/2;
      potant=pot;
      delay_us(100);
      error=pot12-pot;
}


void error_2()
{
      delay_us(200);
      set_adc_channel(1);
      potaux22=read_ADC();
      while(!adc_done()){}
      pot22=(potaux22+potant22)/2;
      potant22=pot22;
      delay_us(100);
      error2=pot2-pot22;
}


void comportamiento()
{

switch(behavior)
{
   case 0:
      break;

   case 1:
      control1();
      control2();
      break;

   case 2:
      vel1();
      control2();
      break;

   case 3:
      vel2();
      control1();
      break;

   case 4:
      vel1();
      vel2();
      break;
}   


}



////////////////////////////////////////////////////////////////// MOTORES //////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////// SERIAL //////////////////////////////////////////////////////////

void catch()
{
   switch(dato)
            {
            case '{':
            refInf=pot12;
            refInf2=pot2;
            
            paso1=9;
            paso2=9;
            break;

            case '}':
            refSup=pot12;
            refSup2=pot2;

            paso1=9;
            paso2=9;
            break;

            case '@':
            printf(usb_cdc_putc,"refInf=%f, refSup=%f, paso=%f, refInf2=%f, refSup2=%f, paso2=%f",refInf,refSup,paso1,refInf2,refSup2,paso2);
            delay_us(10000);
            break;

            case '(':
            paso1=paso1+1;
            break;

            case ')':
            paso1=paso1-1;
            break;

            case '[':
            paso2=paso2+1;
            break;

            case ']':
            paso2=paso2-1;
            break;
            }
}


void serial()
{
//   usb_cdc_putc(dato);
//      dato=getc();
      switch(dato)
      {
         case 'A':
         behavior=2;
         break;

         case 'S':
         behavior=4;
         break;

            case 'Q':
         behavior=1;
         break;
         case 'W':
         behavior=3;
         break;

            case 'Z':
         behavior=0;

         salidaS=0;
         salidaS2=0;
      set_pwm2_duty(0);
      set_pwm1_duty(0);

         break;

         case 'X':
         break;

         case 'O':
         pot12=pot12+10;
         pot2=pot2+10;
         break;
         case 'P':
         pot12=pot12-10;
         pot2=pot2-10;
         break;
         case 'V':
         if(agitado)
         agitado=0;
         else if(!agitado)
         agitado=1;
         break;

      }


   switch(dato)
            {
            case 'T':
            pot12=200;
            break;
            case 'Y':
            pot12=pot12+10;
            break;
            case 'U':
            pot12=pot12-10;
            break;


            case 'G':
            pot2=800;
            break;
            case 'H':
            pot2=pot2+10;
            break;
            case 'J':
            pot2=pot2-10;
            break;



         case '0':
         pot12=refInf;
         pot2=refInf2;
         break;
         case '1':
         pot12=refInf+1*paso1;
         pot2=refInf2+1*paso2;
         break;
         case '2':
         pot12=refInf+2*paso1;
         pot2=refInf2+2*paso2;
         break;
         case '3':
         pot12=refInf+3*paso1;
         pot2=refInf2+3*paso2;
         break;
         case '4':
         pot12=refInf+4*paso1;
         pot2=refInf2+4*paso2;
         break;
         case '5':
         pot12=refInf+5*paso1;
         pot2=refInf2+5*paso2;
         break;
         case '6':
         pot12=refInf+6*paso1;
         pot2=refInf2+6*paso2;
         break;
         case '7':
         pot12=refInf+7*paso1;
         pot2=refInf2+7*paso2;
         break;
         case '8':
         pot12=refInf+8*paso1;
         pot2=refInf2+8*paso2;
         break;
         case '9':
         pot12=refSup;
         pot2=refSup2;
         break;
            }
      catch();   
}


void IMUSerial()
{
      switch(dato)
      {
      case 'a':
      printf(usb_cdc_putc,"%Ld,%Ld,%Ld\n\r",acc_X,acc_Y,acc_Z);
      break;
      
      case 'b':
       printf(usb_cdc_putc,"%f,%f,%f\n\r",accfX,accfY,accfZ);
      break;

      case 'c':
       printf(usb_cdc_putc,"%Ld,%Ld,%Ld\n\r",gyrX,gyrY,gyrZ);
      break;
   
      case 'd':
       printf(usb_cdc_putc,"%f,%f,%f\n\r",angX,angY,angZ);
      break;

      case 'e':
       printf(usb_cdc_putc,"%f,%f,%f\n\r",acc_pitch,acc_roll,acc_yaw);
      break;

      case 'f':
       printf(usb_cdc_putc,"%f,%f,%f\n\r",acc_teta,acc_gama,acc_fi);
      break;


      case 'g':
       printf(usb_cdc_putc,"%Ld,%f,%f\n\r",gyr_rate_y,acc_pitch,angy);
      break;

      case 'h':
          printf(usb_cdc_putc,"%Ld,%f,%f\n\r",gyr_rate_x,acc_roll,angx);
      break;

      case 'i':
          printf(usb_cdc_putc,"%Ld,%f,%f\n\r",gyr_rate_z,acc_yaw,angZ);
      break;

      case 'j':
          printf(usb_cdc_putc,"%f,%f,%f,%f,%f,%f\n\r",acc_pitch,angX,acc_roll,angY,acc_yaw,angZ);
      break;

      case 'k':
          printf(usb_cdc_putc,"%f,%f,%f,%f,%f,%f\n\r",acc_Pitch,angX,acc_Roll,angY,valPitch,valRoll);
      break;

      case '.':
          pitchRoll_flag=!pitchRoll_flag;
      break;
   }
}

////////////////////////////////////////////////////////////////// SERIAL //////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////// MAIN //////////////////////////////////////////////////////////
int1 imu_flag=0;
int1 flex_flag=0;


void main()
{
   set_tris_c(0x00000000);
   set_tris_b(0x00000000);

    setup_ccp1(CCP_PWM);
    setup_ccp2(CCP_PWM);
    setup_timer_2(T2_DIV_BY_1, 255, 1);
    setup_adc_ports(AN0_TO_AN2);
    setup_adc(ADC_CLOCK_DIV_32);

   usb_cdc_init();
   usb_init();

   while (!usb_cdc_connected()) {}
   printf(usb_cdc_putc,"Conectado!");
   iniciarADXL345();
   inciarL3G4200D();
   delay_us(1000000);
   calibrateGyro();
   calibrateGyro2();
   calibrateAccel();


   while(true)
   {
        usb_task();   

   if(usb_cdc_kbhit())
   {
   dato=usb_cdc_getc();
      if(imu_flag)
      IMUSerial();
      else if(flex_flag)
      serial();
   }

   switch(dato)
   {
   case '+':
   imu_flag=1;
   flex_flag=0;
   break;   
   case '-':
   imu_flag=0;
   flex_flag=1;
   break;
   case '*':
   imu_flag=0;
   flex_flag=0;
   break;
   }
   

if(imu_flag)
{
//   IMUSerial();
   imu();
}
else if(flex_flag)
{
  //      serial();   
      flexometro();
      error_1();
      error_2();
   
      comportamiento();
         delay_us(100);   
         printf(usb_cdc_putc,"%Lu,%Lu,%Lu,%Lu,%Lu,%Ld,%Ld,%Ld,%Ld\n\r",flex,pot12,pot,pot2,pot22,error,salidaS,error2,salidaS2);
         delay_us(200);

}


   }
}

////////////////////////////////////////////////////////////////// MAIN //////////////////////////////////////////////////////////
