﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Input;

namespace InterfazRehabilitacion
{
    public class Background
    {

      //  SoundEffect musicBackground;
      //  Song Bmusic;
      //  Texture2D BTexture;
        public Color backColor = Color.CornflowerBlue;
        float TimerIntro = 6;
        public float Timer = 10;
        public float AntFrec;
        public float ResTim;
     //   bool GameOver;
     //   int Points;
        float timerTutorial;
        int currentFrame=1;

        public bool GameON=false;
        public bool SetupON = false;
        public bool GameOver = false;

       // SpriteFont spriteFont;
        SpriteFont GameOverFont;
        SpriteFont PauseFont;
        SpriteFont LittleFont;

        Texture2D manoTexture1;
        Texture2D manoTexture2;
        Texture2D manoTexture3;
        Texture2D manoTexture4;

        Texture2D tuto1Texture;
        Texture2D tuto2Texture;

        Texture2D[] TexturaMano = new Texture2D[7];
        int currentTutorial;

        KeyboardState CurrentKey;
        KeyboardState PreviousKey;

        public enum states
        { 
        setting, tutorialing,waiting, gaming,pausing, ending
        }

        public states currentState=states.setting;


        public void Load(ContentManager Content)
        {
            GameOverFont = Content.Load<SpriteFont>("BigLetters");
            PauseFont = Content.Load<SpriteFont>("PauseLetters");
            LittleFont = Content.Load<SpriteFont>("SpriteFont1");
            tuto1Texture = Content.Load<Texture2D>("Tutorial/hormigas1");
            tuto2Texture = Content.Load<Texture2D>("Tutorial/Arañas1");
            manoTexture1 = Content.Load<Texture2D>("Tutorial/secuencia1");
            manoTexture2 = Content.Load<Texture2D>("Tutorial/secuencia2");
            manoTexture3 = Content.Load<Texture2D>("Tutorial/secuencia3");
            manoTexture4 = Content.Load<Texture2D>("Tutorial/secuencia4");

            TexturaMano[0] = manoTexture1;
            TexturaMano[1] = manoTexture2;
            TexturaMano[2] = manoTexture3;
            TexturaMano[3] = manoTexture4;
            TexturaMano[4] = manoTexture3;
            TexturaMano[5] = manoTexture2;
            TexturaMano[6] = manoTexture1;
            
        }


        public void Update(GameTime gameTime)
        {
            CurrentKey = Keyboard.GetState();
            
            switch (currentState)
            {
                case states.setting:
                    SetupON = true;
                    if (Keyboard.GetState().IsKeyDown(Keys.Space) && CurrentKey != PreviousKey)
                    {
                        currentState = states.tutorialing;
                    }
                    break;

                case states.tutorialing:
                    timerTutorial += (float)gameTime.ElapsedGameTime.TotalMilliseconds;
                    if (timerTutorial > 200)
                    {
                        currentFrame++;
                        timerTutorial = 0;
                    }
                    if (currentFrame >= 7)
                    {
                        currentFrame = 0;
                    }

                    
                    if (Keyboard.GetState().IsKeyDown(Keys.Space) && CurrentKey != PreviousKey)
                    {
                        currentTutorial++;
                        if (currentTutorial > 3)
                        currentState = states.waiting;
                    }
                    
                    break;

                case states.waiting:
                    SetupON = false;
                    TimerIntro -= (float)gameTime.ElapsedGameTime.TotalSeconds;

                    if (TimerIntro < 1)
                    {
                        currentState = Background.states.gaming;
                        GameON = true;
                    }

                    break;

                case states.gaming:

                    if (Keyboard.GetState().IsKeyDown(Keys.LeftControl) && CurrentKey != PreviousKey)
                    {
                        currentState = Background.states.pausing;
                        GameON = false;
                    }

                    if (Timer <= 0)
                    {
                        currentState = Background.states.ending;
                        GameON = false;
                    }

                                     
                    break;
                case states.pausing:

                    if (Keyboard.GetState().IsKeyDown(Keys.LeftControl) && CurrentKey != PreviousKey)
                    {
                        currentState = Background.states.gaming;
                        GameON = true;
                    }

                    break;
                case states.ending:
                    GameOver = true;
                    break;

            }

            PreviousKey = CurrentKey;
 
        }



               
        public void Draw(SpriteBatch spriteBatch)
        {
            switch (currentState)
            {
                case states.setting:
                    backColor = Color.CornflowerBlue;
                    spriteBatch.DrawString(PauseFont, "Ajuste", new Vector2(50, 0), Color.White);
                    spriteBatch.DrawString(LittleFont, "Presione Espacio para continuar... ", new Vector2(100, 500), Color.White);
                    break;
                case states.tutorialing:
                    backColor = Color.White;
                    tutorial(spriteBatch, currentTutorial);
                    break;
                case states.waiting:
                    backColor = Color.CornflowerBlue;
                    spriteBatch.DrawString(GameOverFont, "" + Intro((int)TimerIntro), new Vector2(30, 200), Color.White);
                    break;
                case states.gaming:
                    break;
                case states.pausing:
                    backColor = Color.DarkSlateGray;
                    spriteBatch.DrawString(PauseFont, "PAUSA", new Vector2(20, 100), Color.White);
                    break;
                case states.ending:
                    backColor = Color.Black;
                    spriteBatch.DrawString(GameOverFont, "Fin del\nJuego", new Vector2(50, 0), Color.White);
                    break;

            }
        }


        /////////////////// METODOS DE DRAW /////////////////

        string Intro(int num)
        {
            string S = "";

            switch (num)
            {
                case 5:
                    S = "";
                    break;
                case 4:
                    S = "   " + 3;
                    break;
                case 3:
                    S = "   " + 2;
                    break;
                case 2:
                    S = "   " + 1;
                    break;
                case 1:
                    S = "Ahora";
                    break;


            }
            return S;
        }


        void tutorial(SpriteBatch spriteBatch1, int num)
        { 
        switch(num)
            {
            case 0:
            spriteBatch1.DrawString(LittleFont, "Ayuda a las hormigas a cruzar al otro extremo...", new Vector2(50, 100), Color.Black);
            spriteBatch1.Draw(tuto1Texture,new Rectangle(100,200,300,300), null, Color.White);
            spriteBatch1.DrawString(LittleFont, "Presione Espacio para continuar... ", new Vector2(100, 500), Color.Black);
            break;
            
            case 1:
            spriteBatch1.DrawString(LittleFont, "Realiza el movimiento de la hoja utilizando\nla flexion y extension de los dedos...", new Vector2(50, 100), Color.Black);
            spriteBatch1.Draw(TexturaMano[currentFrame], new Rectangle(100, 200, 200, 200), null, Color.White);
            spriteBatch1.DrawString(LittleFont, "Presione Espacio para continuar... ", new Vector2(100, 500), Color.Black);
            //spriteBatch1.DrawString(LittleFont, "TutorialTime:"+timerTutorial, new Vector2(300, 400), Color.Black);
            //spriteBatch1.DrawString(LittleFont, "TutorialFrame:" + currentFrame, new Vector2(400, 400), Color.Black);
            break;

            case 2:
            spriteBatch1.DrawString(LittleFont, "Cuando aparezca el peligro\ntrata de oponerte a la fuerza...", new Vector2(50, 100), Color.Black);
            spriteBatch1.Draw(tuto2Texture, new Rectangle(100, 200, 300, 300), null, Color.White);
            spriteBatch1.DrawString(LittleFont, "Presione Espacio para continuar... ", new Vector2(100, 500), Color.Black);
            break;
            
            case 3:
                spriteBatch1.DrawString(LittleFont, "Su preparacion ha terminado\nAyude a las hormigas!", new Vector2(100, 200), Color.Black);
                spriteBatch1.DrawString(LittleFont, "Presione Espacio para continuar... ", new Vector2(100, 500), Color.Black);
            break;

            }

        }
        /////////////////////////////////////////////////////

       }
}
