﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO.Ports;
using System.Windows.Forms;

namespace InterfazRehabilitacion
{

    public class SerialCOM
    {
        static public ComboBox cmbPuertos;
        static public CheckBox cBPuertos;
        static public SerialPort Puerto;
        static public Timer timer;


        //Metodo para el control de abrir/cerrar puertos a partir de un CheckBox
        public static void Checked()
        {
            if (cBPuertos.Checked)
            {
                abre_puerto(Puerto, cmbPuertos.Text);

                if (Puerto.IsOpen)
                {
                    cBPuertos.Text = "Puerto Abierto";
                    timer.Enabled = true;
                }
            }
            else
            {
                
                timer.Enabled = false;
                try
                {
                    cierra_puerto(Puerto);
                    cBPuertos.Text = "Puerto Cerrado";
                }
                catch
                {
                    MessageBox.Show("No se puede cerrar");
                    cBPuertos.Checked = true;
                }
            }
        }


        //***********************************PUERTOS********************************//
        //METODO PARA BUSCAR PUERTOS
        public static void busca_puertos(ref ComboBox cb)
        {
            string[] ports = SerialPort.GetPortNames();
            cb.Items.Clear();
            foreach (string port in ports)
            {
                cb.Items.Add(port);
            }
            cb.Text = "Vacio";
        }

        //METODO PARA ABRIR PUERTOS
        public static void abre_puerto(SerialPort Puerto, string Seleccion)
        {
            if (Seleccion != "Vacio") 
            {
              Puerto.PortName = Seleccion;
                Puerto.BaudRate = 9600;
                if (Puerto != null)
                    Puerto.Open();
                MessageBox.Show("Puerto abierto");

            }
            else
            {
                MessageBox.Show("No hay puertos disponibles");
            }
        }

        //METODO PARA CERRAR PUERTOS
        public static void cierra_puerto(SerialPort Puerto)
        {
            if (Puerto != null)
            {
                if (Puerto.IsOpen == true)
                {
                    MessageBox.Show("Cerrando puerto");
                    Puerto.Close();
                    MessageBox.Show("Puerto cerrado");
                }
            }
        }

        //***********************COMUNICACION*******************************//
        public static void enviar(string mensaje)
        {
            if ((Puerto != null) && (Puerto.IsOpen == true))
                Puerto.Write(mensaje);
        }

        public static string recibir(TextBox ReadSerial, String RxString)
        {
            if (Puerto.IsOpen == true)
                return ReadSerial.Text = RxString;
            else return "";
        }

        public static string cadena;
        public static string[] words;
        public int posicion;

        public static string[] timerString(String LaCadena)
        {
            cadena = LaCadena;
            words = cadena.Split(',');
         return words;
        }
    }
}
