﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;

namespace InterfazRehabilitacion
{
    class araña
    {
       public Texture2D Texture;
       Texture2D TextureNormal, TexturePull, TextureBite, TextureBad;

      public Vector2 Position;
      public Vector2 Speed=new Vector2(2,2);
      Alarma Alerta=new Alarma();
      Linea LimiteSuperior = new Linea();
      public Telaraña Telaraña=new Telaraña();
      public bool Collision;
      public bool Limit;
      public float Timer=10;
      public bool Save;
      public bool Win = false;

      public Color[] TelaTextureData;

       public enum states{
          warning, downing, searching, pulling, breaking, biting, dissapearing
            }

      public  states CurrentState = states.warning;

       public araña()
       {
           this.Position = new Vector2(0, -100);
       }

       public void Load(ContentManager Content)
        {
           this.TextureNormal = Content.Load<Texture2D>("Cosa33");
           this.TexturePull = Content.Load<Texture2D>("Cosa33jalando");
           this.TextureBite = Content.Load<Texture2D>("Cosa33mordiendo");
           this.TextureBad = Content.Load<Texture2D>("Cosa33molesto");
                  this.Texture = this.TextureNormal;

            Alerta.Load(Content);
            Alerta.Count = 4;
            LimiteSuperior.Load(Content);
            LimiteSuperior.Position.Y = 170;
            this.Telaraña.Texture1 = Content.Load<Texture2D>("Tela2");

            TelaTextureData = new Color[Telaraña.Texture1.Width * Telaraña.Texture1.Height];
            Telaraña.Texture1.GetData(TelaTextureData);

    }

       public void Update(GameTime gameTime)
        {
            switch (CurrentState)
            { 
                case states.warning:
                    Alerta.Update(gameTime);
                    if (Alerta.Finish == true)
                        CurrentState = states.downing;
                    break;

                case states.downing:
                    if (this.Position.Y < -140)
                        this.Position.Y += this.Speed.Y;
                    else
                    {
                        CurrentState = states.searching;
                        this.Telaraña.Posicion1.X = this.TextureNormal.Width + this.TextureNormal.Width /2+ 95;
                        this.Telaraña.Posicion1.Y = 30; 
                    }
                    break;

                case states.searching:
                    this.Telaraña.Posicion1.Y += (int)Speed.Y;
                    if (this.Collision == true)
                    {
                        CurrentState = states.pulling;
                        SerialCOM.enviar("A");
                    }
                    break;

                case states.pulling:
                   
                    this.Timer-=(float)gameTime.ElapsedGameTime.TotalSeconds;
                    if (Timer <=0)
                    {
                        Save = true;
                    }
                    if (this.Limit == true)
                    {
                        CurrentState = states.biting;
                        Timer = 2;
                        SerialCOM.enviar("Q");
                    }
                    else if (this.Save == true)
                    {
                        CurrentState = states.breaking;
                        SerialCOM.enviar("Q");
                    }
                    break;

                case states.biting:
                    this.Timer -= (float)gameTime.ElapsedGameTime.TotalSeconds;
                    if (Timer <= 0)
                    {
                        Win = false;
                        CurrentState = states.dissapearing;
                    }
                    break;

                case states.breaking:
                    this.Position.Y -= this.Speed.Y;
                    this.Telaraña.Posicion1.Y += (int)this.Speed.Y;

                    if (Position.Y < -1*this.TextureNormal.Height)
                    {
                        Win = true;
                        CurrentState = states.dissapearing;
                    }
                    break;

                case states.dissapearing:
                    break;
            }
        }

       public void Draw(SpriteBatch spriteBatch)
        {
           
           switch (CurrentState)
            {
                case states.warning:
                    Alerta.Draw(spriteBatch);
                    break;

                case states.downing:
                    this.Texture = TextureNormal;
                    spriteBatch.Draw(this.Texture, this.Position, null, Color.White);
                    break;

                case states.searching:
                    spriteBatch.Draw(this.Telaraña.Texture1, this.Telaraña.Posicion1, null, Color.White);
                    spriteBatch.Draw(this.Texture, this.Position, null, Color.White);
                    break;

                case states.pulling:
                    this.Texture = TexturePull;
                    LimiteSuperior.Draw(spriteBatch);
                    spriteBatch.Draw(this.Telaraña.Texture1, this.Telaraña.Posicion1, null, Color.White);
                    spriteBatch.Draw(this.Texture, this.Position, null, Color.White);

                    break;

                case states.biting:
                    this.Texture = TextureBite;
                    spriteBatch.Draw(this.Texture, this.Position, null, Color.White);
                    break;

                case states.breaking:
                    this.Texture = TextureBad;
                    spriteBatch.Draw(this.Texture, this.Position, null, Color.White);
                    break;

                case states.dissapearing:
                    break;
            }
        }
    }

    class Telaraña
    {
       public Texture2D Texture1;
       public Vector2 Posicion1;
    }
}
